<!-- Este componente contiene las funciones de Blockly -->
<template>
  <div>
    <div class="blocklyDivClass" id="blocklyDiv" ref="blocklyDivRef"></div>
    <xml style="display: none" ref="blocklyToolbox"><slot></slot></xml>
    <!-- <xml style="display:none" ref="blocklyToolbox"><block type="controls_if" id=",P{W?c[wEKMe?Z{m$@wL" x="38" y="113"><statement name="DO0"><block type="controls_repeat_ext" id="`8rP4DSI/+*(AMvG-c9R"><value name="TIMES"><block type="math_number" id="(ZRz=BV]+9hV7eX^V4te"><field name="NUM">10</field></block></value></block></statement></block></xml> -->
  </div>
</template>

<script lang="ts">
/**
 * @license
 *
 * Copyright 2019 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * @author Johnny Cubides
 */

import { defineComponent, ref, onMounted, watch } from "vue";
import * as Blockly from "@johnnycubides/blockly-catalejo/";
import * as Es from "@johnnycubides/blockly-catalejo/msg/es";

// TODO: ADD NEW TYPEPROJECT
import "../../blockly-config/luna8266/luna8266";
import "../../blockly-config/chuck/chuck";

import { updateTypedVarModalForChuck } from "../../host/index";

declare var Android: any // eslint-disable-line
Blockly.setLocale(Es);

export default defineComponent({
  props: ["options", "catalejoDataPrj", "positionBufferBlockly"],
  emits: ["loadRefWorkspaceBlockly"],
  setup(props, context) {
    const blocklyDivRef = ref();
    const blocklyToolbox = ref();
    let workspace: Blockly.Workspace;

    watch(
      () => props.options,
      async (newOptions) => {
        console.debug("newOptions");
        //workspace = Blockly.inject(blocklyDivRef.value, newOptions);
        await workspace.updateToolbox(newOptions.toolbox);
        if (props.catalejoDataPrj.getTypePrj() == "chuck") {
          await updateTypedVarModalForChuck(workspace);
        }
        //const code = '<xml xmlns="https://developers.google.com/blockly/xml"><block type="controls_if" id=",P{W?c[wEKMe?Z{m$@wL" x="38" y="113"><statement name="DO0"><block type="controls_repeat_ext" id="`8rP4DSI/+*(AMvG-c9R"><value name="TIMES"><block type="math_number" id="(ZRz=BV]+9hV7eX^V4te"><field name="NUM">10</field></block></value></block></statement></block></xml>'
        //console.log(code);
        //console.log(props.catalejoProjectObj.BLOCKLY);
        Blockly.Xml.clearWorkspaceAndLoadFromXml(
          Blockly.utils.xml.textToDom(props.catalejoDataPrj.getBlocklyCode(0)),
          workspace
        );
      }
    );

    watch(
      () => props.positionBufferBlockly,
      async function loadBlocklyCodeFromBuffer(positionBufferBlockly) {
        Blockly.Xml.clearWorkspaceAndLoadFromXml(
          Blockly.utils.xml.textToDom(
            props.catalejoDataPrj.getBlocklyCode(positionBufferBlockly)
          ),
          workspace
        );
      }
    );

    onMounted(async () => {
      workspace = await Blockly.inject(blocklyDivRef.value, props.options);

      try {
        const code = await Android.getBlocklyCode();
        Blockly.Xml.clearWorkspaceAndLoadFromXml(
          Blockly.utils.xml.textToDom(code),
          workspace
        );
      } catch (Error) {
        console.log("Error por no poder acceder a Androd: ", Error);
        const code =
          '<xml xmlns="https://developers.google.com/blockly/xml"><block type="controls_if" id=",P{W?c[wEKMe?Z{m$@wL" x="38" y="113"><statement name="DO0"><block type="controls_repeat_ext" id="`8rP4DSI/+*(AMvG-c9R"><value name="TIMES"><block type="math_number" id="(ZRz=BV]+9hV7eX^V4te"><field name="NUM">10</field></block></value></block></statement></block></xml>';
        Blockly.Xml.clearWorkspaceAndLoadFromXml(
          Blockly.utils.xml.textToDom(code),
          workspace
        );
      }
      const listEvents = [
        // Blockly.Events.BLOCK_CREATE,
        // Blockly.Events.BLOCK_CHANGE,
        // Blockly.Events.BLOCK_DRAG,
        // Blockly.Events.BLOCK_CREATE,
        Blockly.Events.SELECTED,
      ];

      const onChangeBlockly = (event) => {
        // console.log('catalejo-msg: match: ' + event.type)
        for (const elementEvent in listEvents) {
          if (event.type === listEvents[elementEvent]) {
            // console.log('catalejo-msg: match: ' + event.type)
            try {
              Android.changesDetectedInBlockly();
              break;
            } catch (Error) {
              console.log("Error por no poder acceder a Androd: ", Error);
              break;
            }
          }
        }
      };

      workspace.addChangeListener(onChangeBlockly);

      context.emit("loadRefWorkspaceBlockly", workspace);
    });

    return {
      blocklyDivRef,
      blocklyToolbox,
      // workspace
    };
  },
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style>
.blocklyWorkspace:hover .blocklyTreeLabel {
  display: none;
}

/*
*/
/*
.blocklyFlyoutBackground:active .blocklyTreeLabel {
.blocklyToolboxContents:hover .blocklyTreeLabel {
  display: inline;
}
*/
/*
.blocklyFlyout:hover .blocklyTreeLabel {
  display: inline;
}
*/
.blocklyToolboxContents {
  flex-wrap: inherit; /* wrap, inherit */
}

/* Se trata de la barra de herramientas y categorías de blockly */
.blocklyToolboxDiv {
  /* top: 30px; /* Se le puede indicar que inicie en cualquier lado del div de su entorno */
  /* width: 30px; /* Se indica el ancho inicial que podrá ser controlado por el hover */
  /* height: 100% !important; /* se indica que use todo el div relativo de su entorno */
  background-color: #63a1d2;
}
.blocklyToolboxDiv:hover {
  width: auto;
}

.blocklyDivClass {
  height: 89%;
  width: 100%;
  text-align: left;
  position: absolute;
}

.blocklyTreeLabel {
  display: block-inline;
  color: white;
}
</style>
